#pragma once

#include <glm/glm.hpp>
#include "CullPlane.h"

class FrustumG {

	private:

		enum {
			TOP = 0, BOTTOM, LEFT,
			RIGHT, NEARP, FARP
		};

	public:
		static enum { OUTSIDE, INTERSECT, INSIDE };

		nycto::CullPlane pl[6];

		glm::vec3 ntl, ntr, nbl, nbr, ftl, ftr, fbl, fbr;
		float nearD, farD, ratio, angle, tang;
		float nw, nh, fw, fh;

		FrustumG::FrustumG();
		FrustumG::~FrustumG();

		void setCamInternals(float angle, float ratio, float nearD, float farD);
		void setCamDef(glm::vec3 &p, glm::vec3 &l, glm::vec3 &u);
		int pointInFrustum(glm::vec3 &p);
		int sphereInFrustum(glm::vec3 &p, float raio);
};