#include "GLDebugDrawer.h"

using namespace std;
using namespace nycto;
using namespace nycto::scene;

GLDebugDrawer::GLDebugDrawer(Shader* shader)
	: m_debugMode(0),
	mShader(shader),
	linePositionBufferDataChanged(false)
{
	generateVAO();
	updateVBOs();
}

GLDebugDrawer::~GLDebugDrawer()
{}

void GLDebugDrawer::drawLine(const btVector3& from, const btVector3& to, const btVector3& fromColor, const btVector3& toColor)
{
	linePositionBufferData.push_back(from.getX());
	linePositionBufferData.push_back(from.getY());
	linePositionBufferData.push_back(from.getZ());

	linePositionBufferData.push_back(to.getX());
	linePositionBufferData.push_back(to.getY());
	linePositionBufferData.push_back(to.getZ());

	linePositionBufferDataChanged = true;
}

void GLDebugDrawer::drawLine(const btVector3& from, const btVector3& to, const btVector3& color)
{
	linePositionBufferData.push_back(from.getX());
	linePositionBufferData.push_back(from.getY());
	linePositionBufferData.push_back(from.getZ());

	linePositionBufferData.push_back(to.getX());
	linePositionBufferData.push_back(to.getY());
	linePositionBufferData.push_back(to.getZ());

	/*
	lineColorBufferData.push_back(color.getX());
	lineColorBufferData.push_back(color.getY());
	lineColorBufferData.push_back(color.getZ());
	*/

	linePositionBufferDataChanged = true;
}

void GLDebugDrawer::drawSphere(const btVector3& p, btScalar radius, const btVector3& color)
{
}

void GLDebugDrawer::drawTriangle(const btVector3& a, const btVector3& b, const btVector3& c, const btVector3& color, btScalar alpha)
{
}

void GLDebugDrawer::drawContactPoint(const btVector3& PointOnB, const btVector3& normalOnB, btScalar distance, int lifeTime, const btVector3& color)
{
}

void GLDebugDrawer::reportErrorWarning(const char* warningString)
{
}

void GLDebugDrawer::draw3dText(const btVector3& location, const char* textString)
{
}

void GLDebugDrawer::setDebugMode(int debugMode)
{
	m_debugMode = debugMode;
}

void GLDebugDrawer::drawAll()
{
	//hier wird wirklich gerendert!
	generateVAO();
	updateVBOs();

	//bind to vao and draw lines
	if (linePositionBufferDataChanged)
	{

		GLint positionIndex = glGetAttribLocation(mShader->programHandle, "position");
		if (positionIndex > -1)
		{
			glEnableVertexAttribArray(positionIndex);
			glBindBuffer(GL_ARRAY_BUFFER, linePositionBuffer);
			glVertexAttribPointer(positionIndex, 3, GL_FLOAT, GL_FALSE, 0, 0);
		}

		glDrawArrays(GL_LINES, 0, linePositionBufferData.size());
		glDisableVertexAttribArray(positionIndex);
		glBindVertexArray(0);

		linePositionBufferData.clear();
		lineColorBufferData.clear();
		linePositionBufferDataChanged = false;
	}
}

void GLDebugDrawer::generateVAO()
{
	glGenVertexArrays(1, &vao);
	glBindVertexArray(vao);
}

void GLDebugDrawer::updateVBOs()
{
	if (linePositionBufferDataChanged)
	{
		glGenBuffers(1, &linePositionBuffer);
		glBindBuffer(GL_ARRAY_BUFFER, linePositionBuffer);
		int size = linePositionBufferData.size() * 3 * 2;
		glBufferData(GL_ARRAY_BUFFER, std::min(size, 60000), &linePositionBufferData[0], GL_STATIC_DRAW);
		glBindBuffer(GL_ARRAY_BUFFER, linePositionBuffer);

		glBindBuffer(GL_ARRAY_BUFFER, 0);
	}
}