#pragma once
#include "LinearMath/btIDebugDraw.h"
#include <GL/glew.h>
#include <vector>
#include "../Shader/Shader.h"
#include <iostream>
#include <algorithm> 

namespace nycto
{
	namespace scene
	{
		class GLDebugDrawer : public btIDebugDraw
		{
			int m_debugMode;
			Shader* mShader;

		public:

			GLuint linePositionBuffer;
			GLuint lineColorBuffer;
			std::vector<float> linePositionBufferData;
			std::vector<float> lineColorBufferData;
			GLDebugDrawer(Shader* shader);
			virtual ~GLDebugDrawer();
			virtual void   drawLine(const btVector3& from, const btVector3& to, const btVector3& fromColor, const btVector3& toColor);
			virtual void   drawLine(const btVector3& from, const btVector3& to, const btVector3& color);
			virtual void   drawSphere(const btVector3& p, btScalar radius, const btVector3& color);
			virtual void   drawTriangle(const btVector3& a, const btVector3& b, const btVector3& c, const btVector3& color, btScalar alpha);
			virtual void   drawContactPoint(const btVector3& PointOnB, const btVector3& normalOnB, btScalar distance, int lifeTime, const btVector3& color);
			virtual void   reportErrorWarning(const char* warningString);
			virtual void   draw3dText(const btVector3& location, const char* textString);
			virtual void   setDebugMode(int debugMode);
			virtual int    getDebugMode() const { return m_debugMode; }
			virtual void   drawAll();
			void updateVBOs();

		private:
			GLuint vao;
			void generateVAO();
			bool linePositionBufferDataChanged;
		};
	}
}
