#pragma once

#include "GLDebugDrawer.h"
#include "btBulletDynamicsCommon.h"
#include <glm/glm.hpp>
#include <glm/gtc/type_ptr.hpp>
#include  "../Shader/Shader.h"

namespace nycto
{
	namespace scene
	{

		class PhysicWorld{
		public:
			static btDiscreteDynamicsWorld* Instance();
			static glm::mat4 convertBulletTransformToGLM(btTransform& transform);
			static btTransform convertGLMTransformToBullet(glm::mat4& transform);
			static btVector3 convertGLMVectorToBullet(glm::vec3 vector);
			static glm::vec3 convertBulletVectorToGLM(btVector3& vector);
			static void update(float deltaT);
			static btRigidBody* createCylinder(float radius, float height, float px, float py, float pz, float mass);
			static btRigidBody* createPlane(float width, float height, float px, float py, float pz, float mass);
		private:
			PhysicWorld(){};
			~PhysicWorld();
			static btDiscreteDynamicsWorld* dynamicsWorld;
			static btRigidBody* addCollisionShape(btCollisionShape* colShape, float px, float py, float pz, float mass);
			static GLDebugDrawer* debugDrawer;
			static Shader * shader;
		};
	}
}