#pragma once

#include <GL/glew.h>
#include "SceneObject.h"
#include <GLFW/glfw3.h>

namespace nycto
{
	namespace scene
	{
		class Camera : public SceneObject
		{
		public:
			Camera(glm::mat4& matrix, GLFWwindow* window);
			virtual ~Camera();
			virtual void update(float time_delta);
			glm::mat4 getViewMatrix();
			glm::vec3 getPosition();

		private:
			GLFWwindow* window;
			float const HEIGHT_OF_CAMERA = 1.5;
			double const RADIUS_OF_CAMERA = 0.5;

			glm::mat4 viewMatrix;
			//Position change desired by player in this gamme loop, passed to the physic engine
			glm::vec3 deltaPosition = glm::vec3(0.0f, 0.0f, 0.0f);
			// Initial horizontal angle : toward -Z
			float horizontalAngle = 2.0f;
			// Initial vertical angle : none
			float verticalAngle = 0.0f;
			// Initial Field of View
			float initialFoV = 45.0f;

			float speed; // 3 units / second
			float mouseSpeed = 0.002f;
		};
	}
}