#include "DirectionalLight.h"
#include <glm/glm.hpp>


using namespace nycto;
using namespace nycto::scene;



DirectionalLight::DirectionalLight(glm::vec3 _lightDirection, glm::mat4& _modelMatrix, std::vector<Shader*> shader)
	: SceneObject(_modelMatrix), lightDirection(_lightDirection), shader(shader)
{
	
}

DirectionalLight::~DirectionalLight()
{
	shader.clear();
}

glm::vec3 DirectionalLight::getLightDirection(){
	return lightDirection;
}


void DirectionalLight::draw()
{
	for (std::vector<Shader*>::iterator shaderIter = shader.begin(); shaderIter != shader.end(); ++shaderIter){
		(*shaderIter)->useShader();
		glUniform3f(glGetUniformLocation((*shaderIter)->programHandle, "lightDir"), this->getLightDirection().x, this->getLightDirection().y, this->getLightDirection().z);
	}
}

void DirectionalLight::update(float deltaT)
{
	
}