#pragma once

#include "SceneObject.h"
#include "../Shader/Shader.h"
#include <vector>

namespace nycto
{
	namespace scene
	{
		class DirectionalLight : public SceneObject
		{
		public:
			DirectionalLight(glm::vec3 _lightDirection, glm::mat4& _modelMatrix, std::vector<Shader*> shader);
			virtual ~DirectionalLight();
			virtual void update(float deltaT);
			virtual void draw();
			glm::vec3 getLightDirection();
		private:
			std::vector<Shader*> shader;
			glm::vec3 lightDirection;
		};
	}
}