#include "Object.h"

using namespace nycto;
using namespace nycto::scene;

Object::Object(std::string& objectPath, glm::mat4& _matrix, Shader& _shader, std::string& texturePath)
	: SceneObject(_matrix), shader(&_shader), objectPath(objectPath), texturePath(texturePath)
{
	this->mesh = new Mesh();
	mesh->LoadMesh(objectPath, texturePath);
}
Object::Object(Object &object)
	: SceneObject(object.modelMatrix), shader(object.shader), objectPath(object.objectPath), texturePath(object.texturePath), mesh(object.mesh)
{
}

Object::~Object()
{
	delete mesh; mesh = nullptr;
}

void Object::draw()
{
	shader->useShader();
	auto& model = this->modelMatrix;
	auto model_location = glGetUniformLocation(shader->programHandle, "model");
	glUniformMatrix4fv(model_location, 1, GL_FALSE, glm::value_ptr(model));

	
	auto tex_location = glGetUniformLocation(shader->programHandle, "color_texture");
	glUniform1i(tex_location, 0);
	mesh->Render();
}

void Object::update(float deltaT)
{
}

void Object::setShader(Shader *_shader){
	shader = _shader;
}