#pragma once

#include "SceneObject.h"
#include "../Shader/Shader.h"
#include "Mesh.h"
#include <glm/gtc/type_ptr.hpp>
#include <assimp/Importer.hpp>
#include <assimp/mesh.h>
#include <assimp/postprocess.h>
#include "Texture.h"
#include <glm/gtc/matrix_transform.hpp>
#include <glm/glm.hpp>

namespace nycto
{
	namespace scene
	{
		class Object : public SceneObject
		{
		public:
			Object::Object(std::string& objectPath, glm::mat4& _matrix, Shader& shader, std::string& texturePath);
			Object::Object(Object& object);
			virtual ~Object();
			virtual void update(float deltaT);
			virtual void draw();
			virtual void interactionWithCamera(GLFWwindow* window) {};
			virtual void setShader(Shader *_shader);
		private:
			Mesh* mesh;
			Shader* shader;
			std::string& objectPath;
			std::string& texturePath;
		};
	}
}