#pragma once

#include <glm/glm.hpp>
#include "../Shader/Shader.h"
#include "btBulletDynamicsCommon.h"

namespace nycto
{
	namespace scene
	{
		class SceneObject
		{
		public:
			SceneObject(glm::mat4& _modelMatrix);
			virtual ~SceneObject();
			virtual void update(float time_delta) = 0;
			virtual void draw() {};

			glm::mat4 modelMatrix;
			float euklDistanceXZTo(SceneObject& other);

			btRigidBody* body;

			const int mapHeight = 150;
			const int mapWidth = 150;
		};
	};
};