#include "SkyBox.h"

using namespace nycto;
using namespace nycto::scene;

SkyBox::SkyBox(std::string& objectPath, glm::mat4& _matrix, Shader& _shader, std::string& texturePath)
	: Object(objectPath, _matrix, _shader, texturePath)
{
	body = PhysicWorld::createPlane(mapWidth, mapHeight, 0, 0, 0, 0);
	//disable x,z rotation and y translation
	body->setLinearFactor(btVector3(1, 0, 1));
	body->setAngularFactor(btVector3(0, 1, 0));
	body->setLinearVelocity(btVector3(0, 0, 0));
	this->setUpWalls();
}

SkyBox::~SkyBox()
{

}

void SkyBox::update(float deltaT)
{
	body->activate();
	body->setLinearVelocity(btVector3(0, 0, 0));
	
	wall1->activate();
	wall1->setLinearVelocity(btVector3(0, 0, 0));
	
	wall2->activate();
	wall2->setLinearVelocity(btVector3(0, 0, 0));

	wall3->activate();
	wall3->setLinearVelocity(btVector3(0, 0, 0));

	wall4->activate();
	wall4->setLinearVelocity(btVector3(0, 0, 0));
	
}
void SkyBox::setUpWalls()
{
	wall1 = PhysicWorld::createPlane(mapWidth, mapHeight, 0, 0, mapWidth / 2, 0);
	btTransform tr1;
	tr1.setIdentity();
	btQuaternion quat1;
	quat1.setEuler(0, -1.57, 0); //or quat.setEulerZYX depending on the ordering you want
	tr1.setRotation(quat1);
	wall1->setCenterOfMassTransform(tr1);
	wall1->translate(btVector3(0,0,mapWidth / 2));
	wall1->setLinearFactor(btVector3(1, 0, 1));
	wall1->setAngularFactor(btVector3(0, 1, 0));
	wall1->setLinearVelocity(btVector3(0, 0, 0));

	wall2 = PhysicWorld::createPlane(mapWidth, mapHeight, 0, 0, -mapWidth / 2, 0);
	btTransform tr2;
	tr2.setIdentity();
	btQuaternion quat2;
	quat2.setEuler(0, 1.57, 0); //or quat.setEulerZYX depending on the ordering you want
	tr2.setRotation(quat2);
	wall2->setCenterOfMassTransform(tr2);
	wall2->translate(btVector3(0, 0, -mapWidth / 2));
	wall2->setLinearFactor(btVector3(1, 0, 1));
	wall2->setAngularFactor(btVector3(0, 1, 0));
	wall2->setLinearVelocity(btVector3(0, 0, 0));

	wall3 = PhysicWorld::createPlane(mapWidth, mapHeight, mapWidth / 2, 0, 0, 0);
	btTransform tr3;
	tr3.setIdentity();
	btQuaternion quat3;
	quat3.setEuler(0, 0, 1.57); //or quat.setEulerZYX depending on the ordering you want
	tr3.setRotation(quat3);
	wall3->setCenterOfMassTransform(tr3);
	wall3->translate(btVector3(mapWidth / 2, 0, 0));
	wall3->setLinearFactor(btVector3(1, 0, 1));
	wall3->setAngularFactor(btVector3(0, 1, 0));
	wall3->setLinearVelocity(btVector3(0, 0, 0));

	wall4 = PhysicWorld::createPlane(mapWidth, mapHeight, -mapWidth / 2, 0, 0, 0);
	btTransform tr4;
	tr4.setIdentity();
	btQuaternion quat4;
	quat4.setEuler(0, 0, -1.57); //or quat.setEulerZYX depending on the ordering you want
	tr4.setRotation(quat4);
	wall4->setCenterOfMassTransform(tr4);
	wall4->translate(btVector3(-mapWidth / 2, 0, 0));
	wall4->setLinearFactor(btVector3(1, 0, 1));
	wall4->setAngularFactor(btVector3(0, 1, 0));
	wall4->setLinearVelocity(btVector3(0, 0, 0));
}
