#include "Tree.h"

using namespace nycto;
using namespace nycto::scene;

Tree::Tree(std::string& objectPath, glm::mat4& _matrix, Shader& _shader, std::string& texturePath)
 : Object(objectPath, _matrix, _shader, texturePath)
{
//only for instancing
	calcBoundingSphere();
}
Tree::Tree(Object &tree)
	: Object(tree)
{
	this->placeTreeRamdomly();
	body = PhysicWorld::createCylinder(RADIUS_OF_TREE, HEIGHT_OF_TREE, modelMatrix[3].x, HEIGHT_OF_TREE, modelMatrix[3].z, 0);
	//disable x,z rotation and y translation
	body->setLinearFactor(btVector3(1, 0, 1));
	body->setAngularFactor(btVector3(0, 1, 0));
	body->setLinearVelocity(btVector3(0, 0, 0));
	calcBoundingSphere();
}

Tree::~Tree()
{
	calcBoundingSphere();
}

void Tree::placeTreeRamdomly()
{
	double randomWidth =( static_cast <float> (rand()) / static_cast <float> (RAND_MAX) )* mapWidth;
	double randomHeight =( static_cast <float> (rand()) / static_cast <float> (RAND_MAX) )* mapHeight;

	glm::vec3 randomPosition(randomWidth - (mapWidth / 2), 0, randomHeight - (mapHeight / 2));
	modelMatrix = glm::translate(modelMatrix, randomPosition);
}
void Tree::update(float deltaT)
{
	body->activate();

	body->setLinearVelocity(btVector3(0, 0, 0));
}

void Tree::calcBoundingSphere(){
	centerOfVertices = glm::vec3(this->modelMatrix[3].x, this->modelMatrix[3].y+5, this->modelMatrix[3].z);
	boundingSphereRadius = 50.0f;
}