#pragma once

#include "Object.h"
#include "../Physics/PhysicWorld.h"

namespace nycto
{
	namespace scene
	{
		class Tree : public Object
		{
		public:
			Tree(std::string& objectPath, glm::mat4& _matrix, Shader& _shader, std::string& texturePath);
			Tree(Object &tree);
			~Tree();
			void update(float deltaT);
			virtual void calcBoundingSphere();
			glm::vec3 centerOfVertices;
			float boundingSphereRadius;
		private:
			double const HEIGHT_OF_TREE = 5;
			double const RADIUS_OF_TREE = 0.5;
			void placeTreeRamdomly();

		};
	}
}