#pragma once

#include <iostream>
#include <GL/glew.h>
#include <glm/glm.hpp>
#include <GLFW/glfw3.h>
#include <vector>

namespace nycto
{
	class FrameBufferObject
	{
	public:
		FrameBufferObject(unsigned int width, unsigned int height);
		~FrameBufferObject();

		void generateColorTexture(unsigned int width, unsigned int height);
		void generateDepthTexture(unsigned int width, unsigned int height);

		GLint getColorTexture();
		GLint getDepthTexture();

		void bind();

	private:
		GLuint fbo;
		GLuint texture_color, texture_depth;
		std::vector<GLenum> drawbuffer;
	};
}