#pragma once

#include "Shader.h"
#include "FrameBufferObject.h"
#include "../Scene/Texture.h"
#include "../Scene/PointLight.h"
#include <glm/glm.hpp>
#include <glm/gtc/type_ptr.hpp>

namespace nycto
{
	namespace shader
	{
		class ScreenPlane
		{
		public:
			ScreenPlane(Shader* shader, GLuint scene_colorTexture, GLuint scene_depthTexture);
			~ScreenPlane();
			void draw(float healthPercentage);
			void setTransparency(bool onOff);
			Shader* shader;
		private:
			nycto::scene::PointLight* p;
			static const GLfloat positions[];
			static const GLfloat uvs[];
			GLuint scene_texture_color, scene_texture_depth;
			Texture* gameOverTexture;
			Texture* gameWonTexture;
			GLuint vertexBuffer, uvBuffer, vaoID;
		};
	}
}