#version 330 core

layout(location=0) out vec4 fragColor;

in vec3 P;
in vec3 N;
in vec2 T;
in vec4 S;

uniform sampler2D color_texture;
uniform vec3 lightDir;

uniform int pLightCount;
uniform vec3 pLightPos[12];
uniform int illuminatedFlag;

uniform mat4 DepthBiasMVP;
uniform int myTextureSampler;
uniform sampler2DShadow shadowMap;

void main()
{
	vec4 diffuseTexColor = vec4(texture(color_texture, T).rgb, 1.0);
	float visibility = texture( shadowMap, vec3(S.xy/S.w, (S.z)/S.w) );


		float intensity = visibility * 0.4 *  max(dot(N, normalize(lightDir)), 0.0);
		for (int i=0; i<pLightCount; i=i+1) {
			
			//Euclidic 3D distance
			float LP_distance = sqrt((P.x-pLightPos[i].x)*(P.x-pLightPos[i].x) 
									+(P.y-pLightPos[i].y)*(P.y-pLightPos[i].y) 
									+(P.z-pLightPos[i].z)*(P.z-pLightPos[i].z));
			float attenuation = 1;
			if (LP_distance != 0){attenuation = 1/LP_distance;}

			vec3 L = normalize(pLightPos[i]-P);
			intensity += 3 * attenuation * attenuation * (max(intensity + max(dot(N, L), 0.0), 1.0));
		}
		fragColor = vec4(intensity * diffuseTexColor.r, intensity * diffuseTexColor.g, intensity * diffuseTexColor.b, 1.0);
	

	//Light Position Test:
	//fragColor= vec4(pLightPos[0].x, pLightPos[0].y, pLightPos[0].z, 1.0);

	//Position Test:
	//fragColor = vec4(P.x/10, P.z/10, 0.0, 1.0);
}