#version 330

layout(location=0) in vec3 position;
layout(location=1) in vec3 normal;
layout(location=2) in vec2 uv;

out vec3 P;
out vec3 N;
out vec2 T;
out vec4 S;

uniform mat4 view_proj;
uniform mat4 model;
uniform mat4 biasVP;

void main()
{
	S = biasVP * model * vec4(position,1);
	P = (model * vec4(position, 1)).xyz;
	N = normalize((model * vec4(normal, 0)).xyz);
	T = uv;
	gl_Position = view_proj * model * vec4(position,1);
	
}