#version 330                                                                        
                                                                                    
layout (location = 0) in vec3 position;                                             
layout (location = 1) in vec2 uv;                                             
layout (location = 2) in vec3 normal;                                               
layout (location = 3) in ivec4 BoneIDs;
layout (location = 4) in vec4 Weights; 

out vec3 P;
out vec3 N;
out vec2 T;  
out vec4 S;                                                           

const int MAX_BONES = 98;

uniform mat4 model;
uniform mat4 view_proj;
uniform mat4 gBones[MAX_BONES];
uniform mat4 biasVP;

void main()
{       
	mat4 BoneTransform = gBones[BoneIDs[0]] * Weights[0];
	BoneTransform     += gBones[BoneIDs[1]] * Weights[1];
	BoneTransform     += gBones[BoneIDs[2]] * Weights[2];
	BoneTransform     += gBones[BoneIDs[3]] * Weights[3]; 
	
	P = (model * BoneTransform *vec4(position, 1)).xyz;
	N = normalize((model * BoneTransform * vec4(normal, 0)).xyz);
	T = uv;
	S = biasVP * model * vec4(position,1);
	gl_Position = view_proj * model * BoneTransform *vec4(position,1); 

}

/*
	vec4 skinnedP  = Weights[0] * (gBones[BoneIDs[0]] * vec4(position,0));
		 skinnedP += Weights[1] * (gBones[BoneIDs[1]] * vec4(position,0));
		 skinnedP += Weights[2] * (gBones[BoneIDs[2]] * vec4(position,0));
		 skinnedP += Weights[3] * (gBones[BoneIDs[3]] * vec4(position,0)); 

	//vec4 skinnedN = gBones[BoneIDs[0]] * Weights[0] * vec4(normal,0);
	//	 skinnedN += gBones[BoneIDs[1]] * Weights[1] * vec4(normal,0);
	//	 skinnedN += gBones[BoneIDs[2]] * Weights[2] * vec4(normal,0);
	//	 skinnedN += gBones[BoneIDs[3]] * Weights[3] * vec4(normal,0); 
	
	P = (model * vec4(position,0)).xyz;
	//N = normalize((model * skinnedN).xyz);
	N = (model * vec4(normal,0)).xyz;
	T = uv;
	gl_Position = view_proj * model * vec4(position,0); 



	===================================


	mat4 BoneTransform = gBones[BoneIDs[0]] * Weights[0];
	BoneTransform     += gBones[BoneIDs[1]] * Weights[1];
	BoneTransform     += gBones[BoneIDs[2]] * Weights[2];
	BoneTransform     += gBones[BoneIDs[3]] * Weights[3]; 
	
	P = (model * BoneTransform *vec4(position, 1)).xyz;
	N = normalize((model * BoneTransform * vec4(normal, 0)).xyz);
	T = uv;
	gl_Position = view_proj * model * BoneTransform *vec4(position,1); 

	*/