#pragma once

#include <iostream>
#include <GL/glew.h>
#include <GL/wglew.h>
#include <GLFW/glfw3.h>
#include <glut/glut.h>

#include "DebugContext.h"
#include "Gameplay.h"
#include <iostream>
#include <string>
#include <fstream>

void init(GLFWwindow* window);
void callDebugContext();
int width;
int height;
Gameplay* gameplay;

void main()
{
	string myArray[5];
	ifstream in;
	in.open("Release/config.txt");
	string widthTemp;
	string heightTemp;
	in >> widthTemp;
	in >> heightTemp;
	width = atoi(widthTemp.c_str());
	height = atoi(heightTemp.c_str());

	if (!glfwInit())
	{
		std::cout << "ERROR: Could not init glfw." << std::endl;
		system("PAUSE");
		exit(EXIT_FAILURE);
	}
	//version
	glfwWindowHint(GLFW_CONTEXT_VERSION_MAJOR, 3);
	glfwWindowHint(GLFW_CONTEXT_VERSION_MINOR, 3);
	//no old functions
	glfwWindowHint(GLFW_OPENGL_PROFILE, GLFW_OPENGL_CORE_PROFILE);

	//debug
#if _DEBUG
	// Create a debug OpenGL context or tell your OpenGL library (GLFW, SDL) to do so.
	glfwWindowHint(GLFW_OPENGL_DEBUG_CONTEXT, GL_TRUE);
#endif

	glutInitWindowPosition(500, 500);

	GLFWwindow* window = glfwCreateWindow(width, height, "Nyctophilia", nullptr, nullptr);
	if (!window){
		std::cout << "ERROR: Could not open window." << std::endl;
		glfwTerminate();
		system("PAUSE");
		exit(EXIT_FAILURE);
	}

	glfwMakeContextCurrent(window);
	glewExperimental = true;
	if (glewInit() != GLEW_OK){
		std::cout << "ERROR: Could not init glew." << std::endl;
		glfwTerminate();
		system("PAUSE");
		exit(EXIT_FAILURE);
	}

	//init Debug Context
	callDebugContext();
	init(window);
	//set color of window
	glClearColor(0.8f, 0.8f, 0.8f, 0.8f);
	glViewport(0, 0, width, height);
	gameplay->runProgram();

	glfwTerminate();
}

void init(GLFWwindow* window){

	glfwSetInputMode(window, GLFW_CURSOR, GLFW_CURSOR_HIDDEN);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);
	glfwSetWindowTitle(window, "Nyctophilia");
	
	gameplay = new Gameplay(window, width, height);

	int width;
	int height;



	glfwGetWindowSize(window, &width, &height);

}

void callDebugContext()
{
#if _DEBUG
	// Query the OpenGL function to register your callback function.
	PFNGLDEBUGMESSAGECALLBACKPROC _glDebugMessageCallback = (PFNGLDEBUGMESSAGECALLBACKPROC)wglGetProcAddress("glDebugMessageCallback");
	PFNGLDEBUGMESSAGECALLBACKARBPROC _glDebugMessageCallbackARB = (PFNGLDEBUGMESSAGECALLBACKARBPROC)wglGetProcAddress("glDebugMessageCallbackARB");
	PFNGLDEBUGMESSAGECALLBACKAMDPROC _glDebugMessageCallbackAMD = (PFNGLDEBUGMESSAGECALLBACKAMDPROC)wglGetProcAddress("glDebugMessageCallbackAMD");

	// Register your callback function.
	if (_glDebugMessageCallback != NULL) {
		_glDebugMessageCallback(DebugCallback, NULL);
	}
	else if (_glDebugMessageCallbackARB != NULL) {
		_glDebugMessageCallbackARB(DebugCallback, NULL);
	}

	// Enable synchronous callback. This ensures that your callback function is called
	// right after an error has occurred. This capability is not defined in the AMD
	// version.
	if ((_glDebugMessageCallback != NULL) || (_glDebugMessageCallbackARB != NULL)) {
		glEnable(GL_DEBUG_OUTPUT_SYNCHRONOUS);
	}
#endif
}